// hlavickove subory *******************************************************
// systemove funkcie
#include <math.h>

// .h subor
#include "m3dmath.h"

// konstruktor *************************************************************
m3dmath::m3dmath()
{

}

// destruktor **************************************************************
m3dmath::~m3dmath()
{

}

// vypocet prvkov 3-rozmerneho vektora *************************************
tVec3 m3dmath::Vector(tVec3 vPoint1,tVec3 vPoint2)
{
 vResult.x=vPoint1.x-vPoint2.x;
 vResult.y=vPoint1.y-vPoint2.y;
 vResult.z=vPoint1.z-vPoint2.z;
 return vResult;
}

// sucet vektorov **********************************************************
tVec3 m3dmath::AddVector(tVec3 vVec1,tVec3 vVec2)
{
 vResult.x=vVec1.x+vVec2.x;
 vResult.y=vVec1.y+vVec2.y;
 vResult.z=vVec1.z+vVec2.z;
 return vResult;
}

// delenie vektora skalarom ************************************************
tVec3 m3dmath::DivideVectorByScalar(tVec3 vVec1, float Scalar)
{
 if (Scalar==0.0f) Scalar=1.0f;

 vResult.x=vVec1.x/Scalar;
 vResult.y=vVec1.y/Scalar;
 vResult.z=vVec1.z/Scalar;
 return vResult;
}

// vektorovy sucin dvoch vektorov ******************************************
tVec3 m3dmath::Cross(tVec3 vVec1, tVec3 vVec2)
{
 vResult.x=((vVec1.y*vVec2.z)-(vVec1.z*vVec2.y));
 vResult.y=((vVec1.z*vVec2.x)-(vVec1.x*vVec2.z));
 vResult.z=((vVec1.x*vVec2.y)-(vVec1.y*vVec2.x));
 return vResult;
}

// normalizacia normaly ****************************************************
tVec3 m3dmath::Normalize(tVec3 vNormal)
{
 vMag=(float) (sqrt(vNormal.x*vNormal.x+vNormal.y*vNormal.y+vNormal.z*vNormal.z));
 if (vMag==0.0f) vMag=1.0f;

 vResult.x=vNormal.x/vMag;
 vResult.y=vNormal.y/vMag;
 vResult.z=vNormal.z/vMag;
 return vResult;
}

// vypocet dlzky vektora ***************************************************
float m3dmath::Length(tVec3 vVec1,tVec3 vVec2)
{
 vResult.x=vVec2.x-vVec1.x;
 vResult.y=vVec2.y-vVec1.y;
 vResult.z=vVec2.z-vVec1.z;

 return sqrt(vResult.x*vResult.x+vResult.y*vResult.y+vResult.z*vResult.z);
}
